/*

This is the GLUT binding for newLisp.
(C) Peter van Eerten - Aug 21, 2005

Remarks:

  1) All callbacks can have up to 8 instances
  2) Up to 8 menu's/submenu's may be used

*/

#include "freeglut_newlisp.h"

#ifndef WIN32
#define FGAPIENTRY
#endif

/* Define delay (millisecs) in case no IDLE callback was defined */
#define default_delay 1

/*--------------------------------------------------------------------------*/

void glutDisplayFunc_callback1(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc1;
	sig_counter++;
}

void glutDisplayFunc_callback2(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc2;
	sig_counter++;
}

void glutDisplayFunc_callback3(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc3;
	sig_counter++;
}

void glutDisplayFunc_callback4(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc4;
	sig_counter++;
}

void glutDisplayFunc_callback5(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc5;
	sig_counter++;
}

void glutDisplayFunc_callback6(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc6;
	sig_counter++;
}

void glutDisplayFunc_callback7(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc7;
	sig_counter++;
}

void glutDisplayFunc_callback8(void)
{
	mycallback[sig_counter].type = myglutDisplayFunc8;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback1(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc1;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback2(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc2;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback3(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc3;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback4(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc4;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback5(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc5;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback6(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc6;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback7(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc7;
	sig_counter++;
}

void glutOverlayDisplayFunc_callback8(void)
{
	mycallback[sig_counter].type = myglutOverlayDisplayFunc8;
	sig_counter++;
}

void glutReshapeFunc_callback1(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc1;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback2(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc2;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback3(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc3;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback4(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc4;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback5(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc5;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback6(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc6;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback7(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc7;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutReshapeFunc_callback8(int width, int height)
{
	mycallback[sig_counter].type = myglutReshapeFunc8;
	mycallback[sig_counter].a = width;
	mycallback[sig_counter].b = height;
	sig_counter++;
}

void glutKeyboardFunc_callback1(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc1;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback2(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc2;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback3(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc3;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback4(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc4;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback5(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc5;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback6(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc6;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback7(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc7;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutKeyboardFunc_callback8(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutKeyboardFunc8;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutMouseFunc_callback1(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc1;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback2(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc2;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback3(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc3;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback4(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc4;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback5(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc5;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback6(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc6;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback7(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc7;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseFunc_callback8(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseFunc8;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMotionFunc_callback1(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc1;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback2(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc2;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback3(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc3;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback4(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc4;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback5(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc5;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback6(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc6;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback7(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc7;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutMotionFunc_callback8(int x, int y)
{
	mycallback[sig_counter].type = myglutMotionFunc8;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback1(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc1;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback2(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc2;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback3(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc3;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback4(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc4;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback5(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc5;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback6(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc6;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback7(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc7;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutPassiveMotionFunc_callback8(int x, int y)
{
	mycallback[sig_counter].type = myglutPassiveMotionFunc8;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutVisibilityFunc_callback1(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc1;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback2(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc2;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback3(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc3;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback4(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc4;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback5(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc5;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback6(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc6;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback7(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc7;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutVisibilityFunc_callback8(int state)
{
	mycallback[sig_counter].type = myglutVisibilityFunc8;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback1(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc1;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback2(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc2;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback3(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc3;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback4(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc4;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback5(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc5;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback6(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc6;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback7(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc7;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutEntryFunc_callback8(int state)
{
	mycallback[sig_counter].type = myglutEntryFunc8;
	mycallback[sig_counter].a = state;
	sig_counter++;
}

void glutSpecialFunc_callback1(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc1;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback2(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc2;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback3(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc3;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback4(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc4;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback5(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc5;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback6(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc6;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback7(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc7;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpecialFunc_callback8(int key, int x, int y)
{
	mycallback[sig_counter].type = myglutSpecialFunc8;
	mycallback[sig_counter].a = key;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback1(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc1;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback2(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc2;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback3(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc3;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback4(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc4;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback5(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc5;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback6(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc6;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback7(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc7;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballMotionFunc_callback8(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballMotionFunc8;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback1(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc1;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback2(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc2;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback3(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc3;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback4(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc4;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback5(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc5;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback6(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc6;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback7(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc7;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballRotateFunc_callback8(int x, int y, int z)
{
	mycallback[sig_counter].type = myglutSpaceballRotateFunc8;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	mycallback[sig_counter].c = z;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback1(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc1;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback2(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc2;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback3(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc3;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback4(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc4;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback5(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc5;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback6(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc6;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback7(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc7;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutSpaceballButtonFunc_callback8(int button, int state)
{
	mycallback[sig_counter].type = myglutSpaceballButtonFunc8;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback1(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc1;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback2(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc2;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback3(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc3;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback4(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc4;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback5(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc5;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback6(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc6;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback7(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc7;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutButtonBoxFunc_callback8(int button, int state)
{
	mycallback[sig_counter].type = myglutButtonBoxFunc8;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	sig_counter++;
}

void glutDialsFunc_callback1(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc1;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback2(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc2;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback3(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc3;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback4(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc4;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback5(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc5;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback6(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc6;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback7(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc7;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutDialsFunc_callback8(int dial, int value)
{
	mycallback[sig_counter].type = myglutDialsFunc8;
	mycallback[sig_counter].a = dial;
	mycallback[sig_counter].b = value;
	sig_counter++;
}

void glutTabletMotionFunc_callback1(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc1;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback2(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc2;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback3(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc3;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback4(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc4;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback5(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc5;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback6(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc6;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback7(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc7;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletMotionFunc_callback8(int x, int y)
{
	mycallback[sig_counter].type = myglutTabletMotionFunc8;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback1(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc1;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback2(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc2;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback3(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc3;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback4(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc4;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback5(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc5;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback6(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc6;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback7(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc7;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTabletButtonFunc_callback8(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutTabletButtonFunc8;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutTimerFunc_callback1(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc1;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback2(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc2;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback3(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc3;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback4(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc4;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback5(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc5;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback6(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc6;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback7(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc7;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutTimerFunc_callback8(int val)
{
	mycallback[sig_counter].type = myglutTimerFunc8;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback1(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu1;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback2(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu2;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback3(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu3;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback4(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu4;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback5(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu5;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback6(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu6;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback7(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu7;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutCreateMenu_callback8(int val)
{
	mycallback[sig_counter].type = myglutCreateMenu8;
	mycallback[sig_counter].a = val;
	sig_counter++;
}

void glutMenuStatusFunc_callback(int status, int x, int y)
{
	mycallback[sig_counter].type = myglutMenuStatusFunc;
	mycallback[sig_counter].a = status;
	mycallback[sig_counter].b = x;
	mycallback[sig_counter].c = y;
	sig_counter++;
}

void glutMenuStateFunc_callback(int status)
{
	mycallback[sig_counter].type = myglutMenuStateFunc;
	mycallback[sig_counter].a = status;
	sig_counter++;
}

void muiSetNonMUIcallback_callback (int x, int y)
{
	mycallback[sig_counter].type = mymuiSetNonMUIcallback;
	mycallback[sig_counter].a = x;
	mycallback[sig_counter].b = y;
	sig_counter++;
}

void muiSetCallback_callback1(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback1;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback2(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback2;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback3(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback3;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback4(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback4;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback5(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback5;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback6(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback6;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback7(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback7;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback8(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback8;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback9(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback9;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback10(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback10;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback11(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback11;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback12(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback12;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback13(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback13;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback14(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback14;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback15(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback15;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback16(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback16;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback17(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback17;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback18(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback18;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback19(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback19;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback20(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback20;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback21(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback21;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback22(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback22;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback23(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback23;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback24(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback24;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback25(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback25;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback26(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback26;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback27(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback27;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback28(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback28;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback29(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback29;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback30(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback30;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback31(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback31;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void muiSetCallback_callback32(int muiObject, int muiReturnValue)
{
	mycallback[sig_counter].type = mymuiSetCallback32;
	mycallback[sig_counter].a = muiObject;
	mycallback[sig_counter].b = muiReturnValue;
	sig_counter++;
}

void glutMouseWheelFunc_callback1(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc1;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback2(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc2;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback3(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc3;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback4(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc4;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback5(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc5;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback6(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc6;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback7(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc7;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutMouseWheelFunc_callback8(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutMouseWheelFunc8;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback1(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc1;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback2(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc2;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback3(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc3;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback4(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc4;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback5(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc5;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback6(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc6;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback7(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc7;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

void glutJoystickFunc_callback8(int button, int state, int x, int y)
{
	mycallback[sig_counter].type = myglutJoystickFunc8;
	mycallback[sig_counter].a = button;
	mycallback[sig_counter].b = state;
	mycallback[sig_counter].c = x;
	mycallback[sig_counter].d = y;
	sig_counter++;
}

/*--------------------------------------------------------------------------*/

void FGAPIENTRY reg_glutDisplayFunc()
{
if (display_counter < 8){
	glutDisplayFunc(display_callbacks[display_counter]);
	display_counter++;
}
}

void FGAPIENTRY reg_glutOverlayDisplayFunc()
{
if (overlaydisplay_counter < 8){
	glutOverlayDisplayFunc(overlaydisplay_callbacks[overlaydisplay_counter]);
	overlaydisplay_counter++;
}
}

void FGAPIENTRY reg_glutReshapeFunc()
{
if (reshape_counter < 8){
	glutReshapeFunc(reshape_callbacks[reshape_counter]);
	reshape_counter++;
}
}

void FGAPIENTRY reg_glutKeyboardFunc()
{
if (keyboard_counter < 8){
	glutKeyboardFunc(keyboard_callbacks[keyboard_counter]);
	keyboard_counter++;
}
}

void FGAPIENTRY reg_glutMouseFunc()
{
if (mouse_counter < 8){
	glutMouseFunc(mouse_callbacks[mouse_counter]);
	mouse_counter++;
}
}

void FGAPIENTRY reg_glutMotionFunc()
{
if (motion_counter < 8){
	glutMotionFunc(motion_callbacks[motion_counter]);
	motion_counter++;
}
}

void FGAPIENTRY reg_glutPassiveMotionFunc()
{
if (passivemotion_counter < 8){
	glutPassiveMotionFunc(passivemotion_callbacks[passivemotion_counter]);
	passivemotion_counter++;
}
}

void FGAPIENTRY reg_glutVisibilityFunc()
{
if (visibility_counter < 8){
	glutVisibilityFunc(visibility_callbacks[visibility_counter]);
	visibility_counter++;
}
}

void FGAPIENTRY reg_glutEntryFunc()
{
if (entry_counter < 8){
	glutEntryFunc(entry_callbacks[entry_counter]);
	entry_counter++;
}
}

void FGAPIENTRY reg_glutSpecialFunc()
{
if (special_counter < 8){
	glutSpecialFunc(special_callbacks[special_counter]);
	special_counter++;
}
}

void FGAPIENTRY reg_glutSpaceballMotionFunc()
{
if (spaceballmotion_counter < 8){
	glutSpaceballMotionFunc(spaceballmotion_callbacks[spaceballmotion_counter]);
	spaceballmotion_counter++;
}
}

void FGAPIENTRY reg_glutSpaceballRotateFunc()
{
if (spaceballrotation_counter < 8){
	glutSpaceballRotateFunc(spaceballrotate_callbacks[spaceballrotation_counter]);
	spaceballrotation_counter++;
}
}

void FGAPIENTRY reg_glutSpaceballButtonFunc()
{
if (spaceballbutton_counter < 8){
	glutSpaceballButtonFunc(spaceballbutton_callbacks[spaceballbutton_counter]);
	spaceballbutton_counter++;
}
}

void FGAPIENTRY reg_glutButtonBoxFunc()
{
if (buttonbox_counter < 8){
	glutButtonBoxFunc(buttonbox_callbacks[buttonbox_counter]);
	buttonbox_counter++;
}
}

void FGAPIENTRY reg_glutDialsFunc()
{
if (dials_counter < 8){
	glutDialsFunc(dials_callbacks[dials_counter]);
	dials_counter++;
}
}

void FGAPIENTRY reg_glutTabletMotionFunc()
{
if (tabletmotion_counter < 8){
	glutTabletMotionFunc(tabletmotion_callbacks[tabletmotion_counter]);
	tabletmotion_counter++;
}
}

void FGAPIENTRY reg_glutTabletButtonFunc()
{
if (tabletbutton_counter < 8){
	glutTabletButtonFunc(tabletbutton_callbacks[tabletbutton_counter]);
	tabletbutton_counter++;
}
}

int FGAPIENTRY reg_glutCreateMenu()
{
int i = 0;

if (menu_counter < 8){
	while (i < 8 && menu_list[i] != 0) i++;
	menu_list[i] = glutCreateMenu(menu_callbacks[i]);
	menu_counter++;
	return (menu_list[menu_counter - 1]);
}
return -1;
}

void FGAPIENTRY reg_glutDestroyMenu(int menu)
{
glutDestroyMenu(menu);
menu_list[menu] = 0;
menu_counter--;
}

void FGAPIENTRY reg_glutMenuStatusFunc()
{
glutMenuStatusFunc(glutMenuStatusFunc_callback);
}

void FGAPIENTRY reg_glutMenuStateFunc()
{
glutMenuStateFunc(glutMenuStateFunc_callback);
}

void FGAPIENTRY reg_glutIdleFunc()
{
Idle_Func_Call = 1;
}

void FGAPIENTRY reg_glutTimerFunc(int x, int y)
{
if (timer_counter < 8){
	glutTimerFunc(x, timer_callbacks[timer_counter], y);
	timer_counter++;
}
}

void FGAPIENTRY reg_muiSetNonMUIcallback()
{
muiSetNonMUIcallback(muiSetNonMUIcallback_callback);
}

void FGAPIENTRY reg_muiSetCallback(int object)
{
if (mui_counter < 32) {
	muiSetCallback((muiObject*)object, mui_callbacks[mui_counter]);
	mui_counter++;
}
}

void FGAPIENTRY reg_glutMouseWheelFunc()
{
if (mousewheel_counter < 8){
	glutMouseWheelFunc(mousewheel_callbacks[mousewheel_counter]);
	mousewheel_counter++;
}
}

void FGAPIENTRY reg_glutJoystickFunc(int x)
{
if (joystick_counter < 8){
	glutJoystickFunc(joystick_callbacks[joystick_counter], x);
	joystick_counter++;
}
}

/*--------------------------------------------------------------------------*/

/* Interpreted mainloop */
int FGAPIENTRY glutCallback(void)
{
int i;

/* Reset callback struct */
if (Idle_Func_Call == 1) {
	mycallback[0].type = myglutIdleFunc;	/* Is there an IDLE callback? */
	sig_counter = 1;
}
else {
	sig_counter = 0;
	/* Avoid 100% CPU load if there are no IDLE callbacks*/
	#ifdef WIN32
	Sleep(default_delay);
	#else
	usleep(default_delay*10);
	#endif
}

for (i = MAX_RETURNED_CALLBACKS; i == sig_counter; i--){
	mycallback[i].type = -1;				/* No IDLE callback */
	mycallback[i].a = -1;
	mycallback[i].b = -1;
	mycallback[i].c = -1;
	mycallback[i].d = -1;
}

/* Find event */
glutMainLoopEvent();

/* Return amount of events happened */
return sig_counter;
}

/* Get each individual callback */
int FGAPIENTRY glutCallbackGet(int call)
{
if (call > 0){return mycallback[--call].type;}
return -1;
}

/* Here each callback registration can fetch it's passed values */
int FGAPIENTRY glutCallbackValue(int which, int call)
{
if (call > 0){
	switch(which){
		case 1:	return mycallback[--call].a;
				break;
		case 2:	return mycallback[--call].b;
				break;
		case 3:	return mycallback[--call].c;
				break;
		case 4:	return mycallback[--call].d;
				break;
		default: return -1;
				break;
	}
}
return -1;
}
